# coding: utf-8

"""
    Policy Ranking API

    API to manage policy ranks  # noqa: E501

    OpenAPI spec version: v1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six
from typing import Union

from psc_auth_integration.entities.auth_user_session import AuthUserSession
from psc_auth_integration.entities.auth_api_session import AuthApiSession
from assignments.api_client.policy_ranking.api_client import ApiClient


class PolicyRankApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, session: Union[AuthUserSession, AuthApiSession]):
        self.api_client = ApiClient(session)

    def get_policies_order_by_rank(self, org_key, **kwargs):  # noqa: E501

        """
        Get policies order by rank

        :return: PoliciesOrderResponse
        """

        all_params = ['org_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_policies_order_by_rank" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'org_key' is set
        if ('org_key' not in params or
                params['org_key'] is None):
            raise ValueError("Missing the required parameter `org_key` when calling `get_policies_order_by_rank`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_key' in params:
            path_params['org_key'] = params['org_key']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None

        (data) = self.api_client.call_api('/v1/orgs/{org_key}/policies_order', 'GET', path_params, query_params, body_params, form_params, local_var_files)
        return data

    def perform_policy_arbitration(self, body, org_key, **kwargs):  # noqa: E501

        """
        Get policy with lowest rank

        :return: PoliciesArbitrationResponse
        """

        all_params = ['body', 'org_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method perform_policy_arbitration" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'body' is set
        if ('body' not in params or
                params['body'] is None):
            raise ValueError("Missing the required parameter `body` when calling `perform_policy_arbitration`")  # noqa: E501
        # verify the required parameter 'org_key' is set
        if ('org_key' not in params or
                params['org_key'] is None):
            raise ValueError("Missing the required parameter `org_key` when calling `perform_policy_arbitration`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'org_key' in params:
            path_params['org_key'] = params['org_key']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']

        (data) = self.api_client.call_api('/private/v1/orgs/{org_key}/policy/arbitration', 'POST', path_params, query_params, body_params, form_params, local_var_files)
        return data
